var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var RPCArgs = /** @class */ (function () {
    function RPCArgs(data) {
        if (data === void 0) { data = {}; }
        if (data) {
            this.addr = data.addr || null;
            this.rpcId = Number(data.rpc_id) || null;
            this.callFmt = data.call_fmt || "";
            this.respFmt = data.resp_fmt || "";
            this.args = data.args || [];
            this.timeout = data.timeout || null;
        }
    }
    return RPCArgs;
}());
export { RPCArgs };
var StatefulRPCArgs = /** @class */ (function (_super) {
    __extends(StatefulRPCArgs, _super);
    function StatefulRPCArgs(data) {
        if (data === void 0) { data = {}; }
        var _this = _super.call(this, data) || this;
        _this.currentState = data.cur_state || false;
        _this.transitionStates = data.trans_states || [];
        _this.auto = data.auto || false;
        return _this;
    }
    return StatefulRPCArgs;
}(RPCArgs));
export { StatefulRPCArgs };
var StatefulSwitchArgs = /** @class */ (function () {
    function StatefulSwitchArgs(data) {
        if (data === void 0) { data = {}; }
        this.currentState = false;
        this.transitionStates = [];
        this.rpcs = [];
        if (data) {
            for (var rpc in data.rpcs) {
                this.rpcs.push(new StatefulRPCArgs(rpc));
            }
            this.currentState = data.cur_state || false;
            this.transitionStates = data.trans_states || [];
        }
    }
    return StatefulSwitchArgs;
}());
export { StatefulSwitchArgs };
var WebArgs = /** @class */ (function () {
    function WebArgs(data) {
        if (data === void 0) { data = {}; }
        this.options = new WebOptions(data.options) || data.options;
    }
    return WebArgs;
}());
export { WebArgs };
var WebOptions = /** @class */ (function () {
    function WebOptions(data) {
        if (data === void 0) { data = {}; }
        this.tabViewId = data.tabViewId;
        this.ngComponent = data.ngComponent;
        this.seriesGroup = data.seriesGroup;
        this.downloadable = data.downloadable || false;
        if ('chart' in data) {
            this.chart = data.chart;
        }
        if ('ngComponentInputs' in data) {
            this.ngComponentInputs = data.ngComponentInputs;
        }
    }
    return WebOptions;
}());
export { WebOptions };
var DisplayWidget = /** @class */ (function () {
    function DisplayWidget(data) {
        if (data === void 0) { data = {}; }
        this.label = data.label;
        this.lid = data.lid_hex;
        this.type = data.type;
        this.varType = data.var_type;
        this.derivedType = data.derived_unit_type;
        this.showInApp = data.show_in_app || false;
        this.showInWeb = data.show_in_web || false;
        if (!data.args) {
            this.args = null;
        }
        else if ('auto' in data.args) {
            this.args = new StatefulRPCArgs(data.args);
        }
        else if ('rpcs' in data.args) {
            this.args = new StatefulSwitchArgs(data.args);
        }
        else if ('web' in data.args && this.showInWeb) {
            this.args = new WebArgs(data.args.web);
        }
        else {
            this.args = new RPCArgs(data.args);
        }
    }
    return DisplayWidget;
}());
export { DisplayWidget };
//# sourceMappingURL=displaywidget.js.map