"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ApiFilter = /** @class */ (function () {
    function ApiFilter() {
        this.filters = [];
    }
    ApiFilter.prototype.filterString = function () {
        // Build a '?name1=val1&name2=val2' string
        if (this.filters.length) {
            var dataFilter = '?' + this.filters.join('&');
            return dataFilter;
        }
        return '';
    };
    ApiFilter.prototype.addFilter = function (name, value, unique) {
        if (unique === void 0) { unique = false; }
        var arg = name + '=' + value;
        if (unique) {
            this.removeFilter(name);
        }
        this.filters.push(arg);
    };
    ApiFilter.prototype.removeFilter = function (name) {
        var arg = name + '=';
        this.filters = this.filters.filter(function (item) {
            return item.indexOf(arg) !== 0;
        });
    };
    return ApiFilter;
}());
exports.ApiFilter = ApiFilter;
//# sourceMappingURL=apifilter.js.map