import { Stream, Device, Project, Variable, SensorGraph, VarType, ProjectTemplate } from "../models";
import { IOTileCloud } from "../cloud/iotile-cloud-serv";
export declare enum Response {
    Success = 200,
    Fail401 = 401,
    Fail402 = 402
}
export declare class MockCloud {
    private MockAdapter;
    private cloud;
    projects: Project[];
    devices: Device[];
    variables: Variable[];
    streams: Stream[];
    sensorGraphs: SensorGraph[];
    varTypes: VarType[];
    projTemplates: ProjectTemplate[];
    constructor(cloud: IOTileCloud);
    private buildListResponse;
    private buildParamResponse;
    getStream(slug: string): Stream;
    getDevice(slug: string): Device;
    expectStreamPatch(slug: string, data: {}, responseType: Response, responseData?: {}): void;
    defaultSetup(): void;
}
