export interface MdoDictionary {
    [index: string]: Mdo;
}
export interface SerializedMDOShort {
    m: number;
    d: number;
    o?: number;
}
export interface SerializedMDOLong {
    multiplication_factor: number;
    division_factor: number;
    offset?: number;
    mdo_label?: string;
}
export declare type SerializedMDO = SerializedMDOShort | SerializedMDOLong;
export declare class Mdo {
    m: number;
    d: number;
    o: number;
    label?: string;
    constructor(data?: any);
    equal(other: Mdo): boolean;
    addToObject(obj: {
        [key: string]: any;
    }, longNames: boolean): void;
    toJson(longNames: boolean): SerializedMDO;
    private _retr_dec;
    computeValue(value: number): number;
    setFromMdo(src: Mdo): void;
    setFromFactor(factor: number, invert: boolean): void;
    eq(): string;
    getPatchPayload(): any;
}
