import { Mdo } from "./mdo";
import { Unit } from "./unit";
export interface VariableDictionary {
    [index: string]: Variable;
}
export interface VariableTemplate {
    id: number;
    label: string;
    lid_hex: string;
    derived_lid_hex: string;
    var_type: string;
    default_input_unit: string;
    default_output_unit: string;
    ctype: string;
    m: number;
    d: number;
    o: number;
    app_only: boolean;
    web_only: boolean;
}
export declare class Variable {
    [key: string]: any;
    id: string;
    slug: string;
    lid: number;
    name: string;
    units: string;
    appOnly: boolean;
    webOnly: boolean;
    sysVar: boolean;
    about: string;
    mdo: Mdo;
    inputUnit: Unit | null;
    outputUnit: Unit | null;
    decimalPlaces: number;
    type: string;
    rawData: any;
    project: string;
    constructor(data?: any);
    toJson(): any;
    getHexLid(): string;
    getPatchPayload(): any;
}
