import { Member, MemberDictionary } from './member';
import { Invitation, InvitationPendingDictionary } from './invitation';
import { OrgTemplate } from './org-template';
export declare class Org {
    slug: string;
    name: string;
    thumbnailUrl?: string;
    tinyUrl?: string;
    rawData: any;
    about: string;
    createdBy?: string;
    createdOn?: Date;
    orgTemplate?: OrgTemplate;
    members: Array<Member>;
    memberMap: MemberDictionary;
    pendingInvites: Array<Invitation>;
    pendingInviteMap: InvitationPendingDictionary;
    currentMember?: Member;
    counts?: {
        [index: string]: number;
    };
    constructor(data?: any);
    toJson(): any;
    getPatchPayload(): any;
    addMembers(members: Array<Member>): void;
    getMember(slug: string): Member;
    addPendingInvites(pendingInvites: Array<Invitation>): void;
    getPendingInvite(email: string): Invitation;
}
