import { DisplayWidget } from "./displaywidget";
import { VariableTemplate } from "./variable";
export interface SensorGraphDictionary {
    [index: string]: SensorGraph;
}
export declare class SensorGraph {
    [key: string]: any;
    id: number;
    name: string;
    slug: string;
    org: string;
    projectTemplate: any;
    variableTemplates: Array<VariableTemplate>;
    displayWidgetTemplates: Array<DisplayWidget>;
    uiExtra: any;
    version: string;
    majorVersion: number;
    minorVersion: number;
    patchVersion: number;
    createdOn: string;
    rawData: string;
    constructor(data?: any);
    getVersion(): string;
    getUiExtra(type: string): any;
    getIoInfo(type: string): any;
    getStreamLids(): string[];
    private getIoInfoParameter;
    getSettingsController(lid: string): string;
    getSettingsTemplate(lid: string): string;
    toJson(): any;
}
